<ADDROW 
"ADD ROW    

During floorplan editing, you use ADD ROW to either add one row, a given number of rows, or as many rows as fit in a given area (using a specified fraction of the row height as space between the rows for routing channels). ADD ROW does not place cells.


Syntax

A*DD R*OW 
[TY*PE {typeName | CE*LL cell}] 
[[H*ORIZONTAL | V*ERTICAL] 
[O*RIENTATION {N|FN|S|FS|E|FE|W|FW} 
| [ N*UMROWS number 
| C*HANNELFACTOR chanFactor]]]... 
pt pt 
[F*LIP [E*VERY interval]] ;


Arguments

TYPE typeName
All added rows are to be of the typeName entered with this option. The type must be the name of a site in the LEF file, and the typeName must be the corresponding siteName. 

Using HELP, (?) after TYPE lists the site types from the library to aid selection. Only cells of this type can be placed in the rows added using this option. Default: the first core site type in the database

CELL cell 
All rows added are of the same type as the specified cell. Only cells of this type can be placed in rows added using this option.

[HORIZONTAL | VERTICAL]
Specifies the abutment direction for the standard cells when they are placed in rows added with this command. HORIZONTAL adds cells at the same Y coordinate while the X coordinate is incremented, and VERTICAL adds calls at the same X while Y is incremented. Default: HORIZONTAL

ORIENTATION
The orientation for the rows being added. Possible orientations are determined by the symmetries of the site. Any cell with normal (library) orientation NORTH, which subsequently is added to this row, is added at the orientation entered with this option, or an allowed flip of both the site type and model. Default: NORTH

NUMROWS number 
The number of new rows to place within the rectangle defined by two given points. The two points are entered using the pt pt operands. Default: 1

CHANNELFACTOR chanFactor
 The amount of space to reserve for routing channels between the new rows. Enter the channel factor as a decimal fraction of the height of the row in the range from (-0.9 to 10). For overlapping rows, the CHANNELFACTOR is negative. Default: the value of the Row.Channel.Factor environmental variable

pt pt 
Two points that define the rectangle within which to create the new rows. The two points become diagonally opposite corners of the rectangle. All rows added are completely enclosed by the rectangle.

FLIP
When used without the EVERY option, this option flips every row that is added by this command about its alignment axis. Orientations include: NORTH, FNORTH, SOUTH, FSOUTH, EAST, FEAST, WEST, and FWEST. 

EVERY interval 
FLIP EVERY designates an interval at which rows being added are flipped: FLIP EVERY 2 flips every other row about its alignment axis, FLIP EVERY 3 flips every third row, and so on.


Description

You can run automatic placement to check whether there is enough usable room to accommodate all of the cells that you intend to place in the rows. Use ADD ROW any time after the floorplan has been initialized. 

Define the region in which to add the rows by selecting two diagonally opposite corners of a rectangle. The two points can be selected with the mouse or by entering coordinates for them. If the points are selected with the mouse, after the first point is picked an expandable box is displayed with one corner anchored to that point and the opposite corner attached to the pointer. When you pick the second point, the new rows are highlighted at their locations.

When you enter DONE, the system adds rows evenly across the rectangle, overlapping them if necessary. The graphics window is updated to show the rows.

The maximum number of rows that can be added within the rectangle is determined by the row height, the channel factor, and the height of the rectangle (or the width of the rectangle, for vertical rows). You can use the NUMROWS to specify the maximum number of rows to add. If you do not select the NUMROWS or CHANNELFACTOR options, ADD ROW adds one row.

If the specified number of rows cannot fit into the rectangle, the command adds as many rows as it can fit into the rectangle and issues a warning that states how many of the specified number of rows it was unable to add.

The CHANNELFACTOR option controls the minimum amount of space to leave between the rows. The channel factor value, entered with the CHANNELFACTOR option, is expressed as a decimal fraction of the row height. 

For example, CHANNELFACTOR 0.5 leaves space equal to at least one- half the row height between the rows for routing. If you select the CHANNELFACTOR option, but you do not enter a value, the channel factor is set by the Row.Channel.Factor environmental variable, which defaults to 0. If CHANNELFACTOR is between -0.99 and 0, rows are overlapped by the decimal fraction of the row height.

PCR 18248 If you specify both NUMROWS and CHANNELFACTOR, the command adds as many rows as possible within the specified area while maintaining the specified space between rows. If the specified area is too small for the number of rows and the space between rows, the command adds as many rows as possible while maintaining the specified spacing between rows, then issues a warning showing the number of rows not added.

The TYPE option defines the row type. If you use the TYPE option to designate a cell type or a cell name, only cells of that type or cells with that name can be placed in the added rows. If you do not specify a row TYPE, the added row defaults to the first row type in the library.

The FLIP option flips the rows about their alignment axis (the X axis for horizontal rows or the Y axis for vertical rows). Using the EVERY option, you can flip every row, every other row, every third row, or rows at any interval about their alignment axes. 

You can use the FLIP option, for example, to create rows of placement sites with no space between them, by specifying a channel factor of zero with the CHANNELFACTOR option and using FLIP EVERY to flip every other row.

ADD ROW cannot create rows outside the layout boundary. If you need to add additional rows, you must use MODIFY FLOORPLAN to change the layout boundary to make room for them.

The SnapGrid.Row.Space.X and SnapGrid.Row.Space.Y variables define a grid for row placement. The edges of every row are snapped to this grid when created.


Environmental Variables

Floorplan.Abut.Pairs.Of.Rows
If set to TRUE, then every 2 rows will be abutted.  If set to false, then
row spacing will be distributed evenly in the rows added.

Row.Channel.Factor 
REAL [0.9999, 10.0] - Default: 0.0 - NOVICE 
Ratio of channel height to row height. Used by MODIFY ROW to determine the channel width.

SnapGrid.Row.Space.X 
REAL [0.0, 10000000] - Default: 0.0 - NOVICE 
Distance (in distance units) between the vertical lines of the row placement grid.

SnapGrid.Row.Space.Y 
REAL [0.0, 10000000] - Default: 0.0 - NOVICE 
Distance (in distance units) between the horizontal lines of the row placement grid.
"

	<Type QHELP>
	<Header "Add Row Command Help">
<beginAutoGen "** Do not edit from here to the endAutoGen tag **" >
	<Tag AddRow
		<Toolname gsEnsemble>
		<Version 5.0>
		<Title "Add Row Form Help">
	>
<endAutoGen >
>
